const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Cameras_ptzDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cameras_ptz = await db.cameras_ptz.create(
      {
        id: data.id || undefined,

        modelo: data.modelo || null,
        fabricante: data.fabricante || null,
        local_instalacao: data.local_instalacao || null,
        coordenada_lat: data.coordenada_lat || null,
        coordenada_lon: data.coordenada_lon || null,
        altura_instalacao_m: data.altura_instalacao_m || null,
        angulo_focal: data.angulo_focal || null,
        ip_acesso: data.ip_acesso || null,
        status_operacional: data.status_operacional || null,
        data_instalacao: data.data_instalacao || null,
        observacoes: data.observacoes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await cameras_ptz.setObra(data.obra || null, {
      transaction,
    });

    await cameras_ptz.setClientes(data.clientes || null, {
      transaction,
    });

    return cameras_ptz;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const cameras_ptzData = data.map((item, index) => ({
      id: item.id || undefined,

      modelo: item.modelo || null,
      fabricante: item.fabricante || null,
      local_instalacao: item.local_instalacao || null,
      coordenada_lat: item.coordenada_lat || null,
      coordenada_lon: item.coordenada_lon || null,
      altura_instalacao_m: item.altura_instalacao_m || null,
      angulo_focal: item.angulo_focal || null,
      ip_acesso: item.ip_acesso || null,
      status_operacional: item.status_operacional || null,
      data_instalacao: item.data_instalacao || null,
      observacoes: item.observacoes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const cameras_ptz = await db.cameras_ptz.bulkCreate(cameras_ptzData, {
      transaction,
    });

    // For each item created, replace relation files

    return cameras_ptz;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const cameras_ptz = await db.cameras_ptz.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.modelo !== undefined) updatePayload.modelo = data.modelo;

    if (data.fabricante !== undefined)
      updatePayload.fabricante = data.fabricante;

    if (data.local_instalacao !== undefined)
      updatePayload.local_instalacao = data.local_instalacao;

    if (data.coordenada_lat !== undefined)
      updatePayload.coordenada_lat = data.coordenada_lat;

    if (data.coordenada_lon !== undefined)
      updatePayload.coordenada_lon = data.coordenada_lon;

    if (data.altura_instalacao_m !== undefined)
      updatePayload.altura_instalacao_m = data.altura_instalacao_m;

    if (data.angulo_focal !== undefined)
      updatePayload.angulo_focal = data.angulo_focal;

    if (data.ip_acesso !== undefined) updatePayload.ip_acesso = data.ip_acesso;

    if (data.status_operacional !== undefined)
      updatePayload.status_operacional = data.status_operacional;

    if (data.data_instalacao !== undefined)
      updatePayload.data_instalacao = data.data_instalacao;

    if (data.observacoes !== undefined)
      updatePayload.observacoes = data.observacoes;

    updatePayload.updatedById = currentUser.id;

    await cameras_ptz.update(updatePayload, { transaction });

    if (data.obra !== undefined) {
      await cameras_ptz.setObra(
        data.obra,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await cameras_ptz.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return cameras_ptz;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cameras_ptz = await db.cameras_ptz.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of cameras_ptz) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of cameras_ptz) {
        await record.destroy({ transaction });
      }
    });

    return cameras_ptz;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cameras_ptz = await db.cameras_ptz.findByPk(id, options);

    await cameras_ptz.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await cameras_ptz.destroy({
      transaction,
    });

    return cameras_ptz;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const cameras_ptz = await db.cameras_ptz.findOne(
      { where },
      { transaction },
    );

    if (!cameras_ptz) {
      return cameras_ptz;
    }

    const output = cameras_ptz.get({ plain: true });

    output.obra = await cameras_ptz.getObra({
      transaction,
    });

    output.clientes = await cameras_ptz.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.obras,
        as: 'obra',

        where: filter.obra
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.obra
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_obra: {
                    [Op.or]: filter.obra
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.modelo) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('cameras_ptz', 'modelo', filter.modelo),
        };
      }

      if (filter.fabricante) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('cameras_ptz', 'fabricante', filter.fabricante),
        };
      }

      if (filter.local_instalacao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'cameras_ptz',
            'local_instalacao',
            filter.local_instalacao,
          ),
        };
      }

      if (filter.angulo_focal) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'cameras_ptz',
            'angulo_focal',
            filter.angulo_focal,
          ),
        };
      }

      if (filter.ip_acesso) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('cameras_ptz', 'ip_acesso', filter.ip_acesso),
        };
      }

      if (filter.status_operacional) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'cameras_ptz',
            'status_operacional',
            filter.status_operacional,
          ),
        };
      }

      if (filter.observacoes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'cameras_ptz',
            'observacoes',
            filter.observacoes,
          ),
        };
      }

      if (filter.coordenada_latRange) {
        const [start, end] = filter.coordenada_latRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            coordenada_lat: {
              ...where.coordenada_lat,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            coordenada_lat: {
              ...where.coordenada_lat,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.coordenada_lonRange) {
        const [start, end] = filter.coordenada_lonRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            coordenada_lon: {
              ...where.coordenada_lon,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            coordenada_lon: {
              ...where.coordenada_lon,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.altura_instalacao_mRange) {
        const [start, end] = filter.altura_instalacao_mRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            altura_instalacao_m: {
              ...where.altura_instalacao_m,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            altura_instalacao_m: {
              ...where.altura_instalacao_m,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.data_instalacaoRange) {
        const [start, end] = filter.data_instalacaoRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_instalacao: {
              ...where.data_instalacao,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_instalacao: {
              ...where.data_instalacao,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.cameras_ptz.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('cameras_ptz', 'modelo', query),
        ],
      };
    }

    const records = await db.cameras_ptz.findAll({
      attributes: ['id', 'modelo'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['modelo', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.modelo,
    }));
  }
};
